=== CSXCAD/CMakeLists.txt ===
--- 
+++ 
@@ -9,8 +9,6 @@
 PROJECT(CSXCAD CXX C)
 
 cmake_minimum_required(VERSION 2.8)
-
-set (CMAKE_CXX_FLAGS -fPIC )
 
 # default
 set(LIB_VERSION_MAJOR 0)
@@ -116,11 +114,18 @@
   date_time
   serialization
   chrono
-  REQUIRED
 )
 
 # vtk
-find_package(VTK REQUIRED COMPONENTS vtkIOGeometry vtkIOPLY NO_MODULE)
+if (WIN32)
+    find_package(VTK 6.1 REQUIRED)
+else()
+    # prefer >=6.1, fallback to >=5.4
+    find_package(VTK 6.1 COMPONENTS vtkIOGeometry vtkIOPLY NO_MODULE)
+    IF (NOT ${VTK_FOUND})
+        find_package(VTK REQUIRED)
+    endif()
+endif()
 
 message(STATUS "Found package VTK. Using version " ${VTK_VERSION})
 include(${VTK_USE_FILE})
