=== debian/control ===
Source: openems
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
Section: electronics
Priority: optional
Build-Depends: debhelper (>= 11),
               cmake,
               libhdf5-dev,
               libboost-all-dev,
               libcgal-dev,
               libcgal-qt5-dev,
               libtinyxml-dev,
               libvtk6-qt-dev,
               libfparser-dev,
# It is called octave-pkg-dev in stretch
# and dh-octave in sid
               dh-octave | octave-pkg-dev,
               chrpath,
               txt2man
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/openems
Vcs-Git: https://salsa.debian.org/science-team/openems.git
Homepage: http://openems.de

Package: openems
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libopenems0 (= ${binary:Version}),
         libcsxcad0 (= ${binary:Version}),
         libqcsxcad0 (= ${binary:Version}),
         libnf2ff0 (= ${binary:Version})
Recommends: octave-openems
Description: Electromagnetic simulator
 This is a simulator for electromagnetic problems using the FDTD
 (Finite-difference time-domain method)  algorithm.
 .
 The FDTD algorithm is a popular algorithm for solving electromagnetic problems
 in the time domain.

Package: libopenems0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Library for the electromagnetic simulator using the FDTD method
 The finite difference time domain method is a popular numerical algorithm
 for solving electromagnetic problems.
 .
 This package contains the library used by openEMS.

Package: libcsxcad0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Continuous Structure XML library for openEMS
 A C++ library to describe geometrical objects and their physical or
 non-physical properties.
 .
 openEMS is a simulator for electromagnetic problems using
 the FDTD algorithm.

Package: libqcsxcad0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: QT Gui Library for Visualization of Continuous Structure XML
 Continuous structure XML (libcsxcad) is a way to describe geometrical objects
 and their physical or non-physical properties. This library provides
 functions to show this in a GUI.
 .
 openEMS is a simulator for electromagnetic problems using
 the FDTD algorithm.

Package: libnf2ff0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Near-field to far-field transform library
 This is a library for the near-field to far-field transform used
 by openEMS.
 .
 It is needed by the nf2ff utility.
 .
 openEMS is a simulator for electromagnetic problems using
 the FDTD algorithm.

Package: libopenems-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libopenems0 (= ${binary:Version}),
         libcsxcad0 (= ${binary:Version}),
         libqcsxcad0 (= ${binary:Version}),
         libnf2ff0 (= ${binary:Version}),
         libfparser-dev
Multi-Arch: same
Description: Development files for openems
 This package contains the development files for all
 the libraries provided by openEMS.
 .
 openEMS is a simulator for electromagnetic problems using
 the FDTD algorithm.

Package: octave-openems
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         openems,
         octave,
         epstool,
         transfig
Description: Octave interface for openems
 This package contains the octave-files needed for
 openEMS. The are installed such that they can be used
 after running "pkg load openems" or "pkg load csxcad".
 .
 openEMS is a simulator for electromagnetic problems using
 the FDTD algorithm.
