=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\.\d+//,\
oversionmangle=s/$/\+dfsg\.1/ \
http://openems.de/download/src/openEMS-v(\S+)\.tar\.(?:bz2|gz|xz)
